unit U_ShaRKList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  ComObj, MovePanel, cxLookAndFeels, cxLookAndFeelPainters, cxNavigator,
  dxBarBuiltInMenu, dxCore, ActiveX;

type
  FdDy = record
    inc: integer; //客户端套接字句柄
    FDdys: string[32]; //客户端套接字
    FdDysName: string[32]; //客户端套接字
  end;

  TfrmShaRKList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Y_CodeName: TEdit;
    FactoryName: TEdit;
    Y_ID: TEdit;
    Y_Spec: TEdit;
    CRType: TComboBox;
    Label6: TLabel;
    Y_CF: TEdit;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Note: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    v1Column16: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    Label11: TLabel;
    FromFactoryName: TEdit;
    v1Column10: TcxGridDBColumn;
    Label9: TLabel;
    ToFactoryName: TEdit;
    cxTabControl1: TcxTabControl;
    Label13: TLabel;
    BatchNo: TEdit;
    ToolButton1: TToolButton;
    v1Price: TcxGridDBColumn;
    v1ComTaiTou: TcxGridDBColumn;
    Label14: TLabel;
    SyrName: TEdit;
    Note1: TMemo;
    Button1: TButton;
    v1filler: TcxGridDBColumn;
    v1FillNo: TcxGridDBColumn;
    ToolButton2: TToolButton;
    RM2: TRMGridReport;
    v1Ssel: TcxGridDBColumn;
    Panel2: TPanel;
    FQty: TEdit;
    ToolButton3: TToolButton;
    OpenDialog1: TOpenDialog;
    MovePanel1: TMovePanel;
    v1Column12: TcxGridDBColumn;
    Label7: TLabel;
    FactType: TComboBox;
    PopupMenu1: TPopupMenu;
    MenuItem1: TMenuItem;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    ADOprint: TADOQuery;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure Y_IDKeyPress(Sender: TObject; var Key: Char);
    procedure Y_IDChange(Sender: TObject);
    procedure Y_SpecChange(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure BatchNoKeyPress(Sender: TObject; var Key: Char);
    procedure ToolButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Tv1DblClick(Sender: TObject);
  private
    canshu1, canshu2, canshu3: string;
    procedure InitGrid();
    { Private declarations }
  public
    dFdDy: array[0..30] of FdDy; //客户端连接数组
    { Public declarations }
  end;

//var
 // frmShaRKList: TfrmShaRKList;

implementation

uses
  U_DataLink, U_RTFun, U_ShaRKInPut, U_Fun, U_OldShaRKList;

{$R *.dfm}

procedure TfrmShaRKList.FormDestroy(Sender: TObject);
begin
  //frmShaRKList:=nil;
end;

procedure TfrmShaRKList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmShaRKList.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  EndDate.DateTime := SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  canshu3 := Trim(DParameters3);
end;

procedure TfrmShaRKList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
     // Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.*  ');
      sql.Add(' from CK_Yarn_CR A');
//      sql.Add(' inner join BS_Company_Main B on B.Code=A.FactoryNo');
      sql.add(' where A.CRTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
      sql.Add(' and A.CRTime<''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
      sql.Add(' and isnull(CKName,'''')=''纱线''');
      SQL.Add(' and CRFlag=''入库''  ');
      SQL.Add(' order by CRTime desc');
//      ShowMessage(SQL.Text);
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;

end;

procedure TfrmShaRKList.TBRafreshClick(Sender: TObject);
begin
  Panel1.SetFocus;

  InitGrid();
end;

procedure TfrmShaRKList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmShaRKList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('纱线入库列表1', Tv1, '纱线仓库');
  Close;
end;

procedure TfrmShaRKList.FormShow(Sender: TObject);
var
  fsj: string;
begin
  ReadCxGrid('纱线入库列表1', Tv1, '纱线仓库');
  if Trim(Self.Caption) = '纱线入库管理' then
  begin
//    TBEdit.Visible:=False;
//    TBDel.Visible:=False;
  end
  else if Trim(Self.Caption) = '纱线入库查询' then
  begin
    TBAdd.Visible := False;
    TBDel.Visible := False;
    TBEdit.Visible := False;

    cxTabControl1.Visible := False;
  end;
  fsj := 'select distinct(Crtype) name from CK_Yarn_CR where ckname=''纱线'' and crflag=''入库''  ';
  SInitComBoxBySql(ADOQueryCmd, CRType, False, fsj);
  //InitGrid();
end;

procedure TfrmShaRKList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel('纱线入库列表', cxGrid2);
end;

procedure TfrmShaRKList.TBFindClick(Sender: TObject);
begin
  Panel1.SetFocus;
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmShaRKList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmShaRKList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmShaRKList.TBDelClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  if Trim(CDS_Main.fieldbyname('Y_ID').AsString) <> '' then
  begin
    if Trim(CDS_Main.fieldbyname('CRType').AsString) = '平移入库' then
    begin
      Application.MessageBox('平移入库的数据为自动生成，不能删除!', '提示', 0);
      Exit;
    end;

    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_Yarn_CR where KCID=''' + Trim(CDS_Main.fieldbyname('Y_ID').AsString) + '''');
      sql.Add(' and CRQtyFlag=-1');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      Application.MessageBox('已有出库记录，不能删除!', '提示', 0);
      Exit;
    end;
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;

    MovePanel1.Visible := True;
    MovePanel1.Refresh;

    try
      ADOQueryCmd.Connection.BeginTrans;
      with CDS_Main do
      begin
        while CDS_Main.Locate('SSel', true, []) = True do
        begin
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add(' delete CK_Yarn_CR where Y_ID=''' + Trim(CDS_Main.fieldbyname('Y_ID').AsString) + '''');
            ExecSQL;
          end;
          Edit;
          FieldByName('SSel').Value := False;
          Post;
        end;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Main.Delete;
      MovePanel1.Visible := False;
      TBRafresh.Click;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      MovePanel1.Visible := False;
      Application.MessageBox('删除异常!', '提示', 0);
    end;

  end
  else
  begin
    CDS_Main.Delete;
  end;
end;

procedure TfrmShaRKList.TBAddClick(Sender: TObject);
begin

  try
    frmShaRKInPut := TfrmShaRKInPut.Create(Application);
    with frmShaRKInPut do
    begin
      FBCId := '';
      frmShaRKInPut.canshu3 := Trim(Self.canshu3);
      if ShowModal = 1 then
      begin
        Self.Panel1.SetFocus;
        Self.InitGrid();
      end;
    end;
  finally
    frmShaRKInPut.Free;
  end;
end;

procedure TfrmShaRKList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  if Trim(CDS_Main.fieldbyname('CRType').AsString) = '平移入库' then
  begin
    Application.MessageBox('平移入库的数据为自动生成，不能修改!', '提示', 0);
    Exit;
  end;

  try
    frmShaRKInPut := TfrmShaRKInPut.Create(Application);
    with frmShaRKInPut do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('Y_ID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      if ShowModal = 1 then
      begin
        Self.Panel1.SetFocus;
        Self.InitGrid();
      end;
    end;
  finally
    frmShaRKInPut.Free;
  end;
end;

procedure TfrmShaRKList.Y_IDKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    {if Length(Trim(Y_ID.Text))<4 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add(' select A.* ');
        sql.Add(',ConNo=(select ConNo from Contract_Main CM where CM.MainId=A.CGMainId)');
        //sql.Add(' ,ConNo=(select ConNo from Contract_Main CM where CM.MainId=A.CGMainId )');
        sql.Add(' from CK_SXPB_CR A');
        sql.add(' where Y_ID like :SXID');
        Parameters.ParamByName('SXID').Value:='%'+Trim(SXID.Text)+'%';
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain,CDS_Main);
      SInitCDSData20(ADOQueryMain,CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end;  }
  end;
end;

procedure TfrmShaRKList.Y_IDChange(Sender: TObject);
begin
  if Length(Trim(Y_ID.Text)) < 4 then
  begin
    if Trim(Y_ID.Text) <> '' then
      Exit;
  end;
  TBFind.Click;
end;

procedure TfrmShaRKList.Y_SpecChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmShaRKList.FactoryNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmShaRKList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmShaRKList.BatchNoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key <> #13 then
    Exit;
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      sql.Add(' from CK_SXPB_CR A');
      sql.add(' where A.BatchNo=''' + Trim(BatchNo.Text) + '''');
      sql.Add(' and isnull(CKName,'''')=''纱线''');
      SQL.Add(' and CRFlag=''入库''  ');
      {if Trim(canshu2)<>'' then
      begin
        SQL.Add(' and isnull(DeptName,'''')='''+Trim(canshu2)+'''');
      end;}
      if cxTabControl1.TabIndex = 0 then
      begin
        Sql.Add(' and ZFFlag=0 ');
      end
      else if cxTabControl1.TabIndex = 1 then
      begin
        Sql.Add(' and ZFFlag=1 ');
      end;
      SQL.Add(' order by CRTime desc');
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmShaRKList.ToolButton1Click(Sender: TObject);
var
  filepath: string;
  mBegdate, mEnddate: string;
  FName, FNameSX, FNameJX: string;
  i: Integer;
begin

//  for i := 0 to Tv1.ColumnCount - 1 do
//  begin
//    FName := Tv1.Columns[i].DataBinding.FilterFieldName;
//    FNameSX := Trim(FName) + '-1';
//    FNameJX := Trim(FName) + '-2';
//    CDS_Main.AddIndex(FNameSX, FName, []);             { 正序 }
//    CDS_Main.AddIndex(FNameJX, FName, [ixDescending]); { 倒序 }
//    if Tv1.Columns[i].SortOrder = soDescending then
//    begin
//      CDS_Main.IndexName := FNameJX;
//    end
//    else if Tv1.Columns[i].SortOrder = soAscending then
//    begin
//      CDS_Main.IndexName := FNameSX;
//    end;
//  end;

  with ADOprint do
  begin
    Close;
    sql.Clear;
    sql.Add(' select FactoryName,crtime=convert(varchar(10),crtime,120),Y_CodeName,batchno,price,sum(qty)qty,sum(money)money ');
    sql.Add(',XJMONEY=(SELECT SUM(MONEY) FROM  CK_Yarn_CR B WHERE B.FACTORYNAME=A.FACTORYNAME      ');
    sql.add('  AND  convert(varchar(10),B.crtime,120)=  convert(varchar(10),A.crtime,120)');

    sql.Add(') from CK_Yarn_CR A');
    sql.add(' where A.CRTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
    sql.Add(' and A.CRTime<''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
    sql.Add('   and isnull(CKName,'''')=''纱线''');
    SQL.Add(' and CRFlag=''入库'' AND crtype=''采购入库'' ');
    SQL.Add('GROUP BY FactoryName,convert(varchar(10),crtime,120),Y_CodeName,batchno,price');
    SQL.Add('ORDER BY convert(varchar(10),crtime,120),FactoryName,Y_CodeName');
//    ShowMessage(SQL.Text);
    Open;
  end;

  mBegdate := FormatDateTime('yyyy-MM-dd', begdate.Date);
  mEnddate := FormatDateTime('yyyy-MM-dd', enddate.Date);
  if CDS_Main.IsEmpty then
    exit;

  ExportFtErpFile('纱线入库报表.rmf', ADOQueryTemp);
  filepath := ExtractFilePath(Application.ExeName) + 'report\纱线入库报表.rmf';
  if FileExists(filepath) then
  begin
      //RM1.DefaultCopies := 2;
    RM1.LoadFromFile(filepath);
    RM1.ShowReport;
  end
  else
  begin
    Application.MessageBox(PChar('没有找' + filepath), '提示', 0);
  end;

end;

procedure TfrmShaRKList.Button1Click(Sender: TObject);
begin
  if Note1.Text = '' then
  begin
    application.MessageBox('修改备注不能为空', '提示');
    exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' UPdate CK_Yarn_CR Set XGNote=''' + trim(Note1.Text) + '''');
      sql.Add(' where Y_ID=''' + Trim(CDS_Main.fieldbyname('Y_ID').AsString) + '''');
      ExecSQL;
    end;
    with CDS_Main do
    begin
      edit;
      FieldByName('XGNote').Value := Trim(Note1.Text);
    end;
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('修改异常!', '提示', 0);
  end;
end;

procedure TfrmShaRKList.ToolButton2Click(Sender: TObject);
var
  filepath: string;
  mBegdate, mEnddate: string;
  FName, FNameSX, FNameJX: string;
  i: Integer;
  maxno, fPrintFile: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('Ssel', True, []) = false then
  begin
    application.MessageBox('没有选择数据', '提示');
    exit;
  end;
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    first;
    while not eof do
    begin
      if FieldByName('Ssel').AsBoolean = True then
      begin
        with ADOQueryCmd do
        begin
          Filtered := False;
          Close;
          sql.Clear;
          sql.Add(' select A.* ');
          sql.Add(',FillNo=(select B.Userid From SY_User B where B.UserName=A.Filler)');
          sql.Add(' from CK_Yarn_CR A');
          sql.add(' where A.Y_ID=''' + Trim(CDS_Main.Fieldbyname('Y_ID').asstring) + '''');
          sql.Add(' and isnull(CKName,'''')=''纱线''');
          SQL.Add(' and CRFlag=''入库''  ');
          Open;
        end;
        SCreateCDS20(ADOQueryCmd, CDS_HZ);
        SInitCDSData20(ADOQueryCmd, CDS_HZ);
        try
          Moudle := LoadLibrary('MakeQRBarcode.dll');
          @Makebar := GetProcAddress(Moudle, 'Make');
          @Mixtext := GetProcAddress(Moudle, 'MixText');
          Txt := Trim(CDS_HZ.Fieldbyname('Y_ID').asstring);
          fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
            CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
          if FileExists(fImagePath) then
            DeleteFile(fImagePath);
          Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
        except
          application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
          exit;
        end;
        for i := 0 to StrToInt(FQty.Text) - 1 do
        begin
          filepath := ExtractFilePath(Application.ExeName) + 'report\纱线入库标签.rmf';
          if not FileExists(Pchar(filepath)) then
          begin
            application.MessageBox(pchar('文件[' + filepath + ']不存在！'), '提示信息', MB_IConError);
            exit;
          end;
          RMVariables['QRBARCODE'] := fImagePath;
          RM2.LoadFromFile(filepath);
          RM2.PrintReport;
        end;
      end;
      next;
    end;
  end;
  CDS_Main.EnableControls;
end;

procedure TfrmShaRKList.ToolButton3Click(Sender: TObject);
var
  excelApp, WorkBook: Variant;
  i, j, k, ExcelRowCount: integer;
  Maxno: string;
begin

  if GetLSNo(ADOQueryCmd, Maxno, 'YRD', 'CK_Yarn_CR', 4, 1) = False then
  begin
    Application.MessageBox('取最大号失败！', '提示', 0);
    Exit;
  end;

  try
    excelApp := CreateOleObject('Excel.Application');
    openDialog1.Filter := '*.CSV;*.xls';
    if opendialog1.Execute then
    begin
      WorkBook := excelApp.WorkBooks.Open(OpenDialog1.FileName);
    end
    else
      exit;

    excelApp.Visible := false;
    ExcelRowCount := WorkBook.WorkSheets[1].UsedRange.Rows.Count;
  except
    application.MessageBox('加载EXCEL错误！', '错误信息', MB_ICONERROR);
    exit;
  end;

  try
    k := 0;
    for i := 1 to 30 do
    begin
      if trim(excelApp.Cells[1, i].value) = '' then
        break;
      
      //遍历界面绑定界面中显示的字段和名称
      for j := 0 to Tv1.ColumnCount - 1 do
      begin
        if trim(excelApp.Cells[1, i].value) = trim(Tv1.Columns[j].Caption) then
        begin
          dFdDy[k].inc := i;
          dFdDy[k].FDdys := trim(Tv1.Columns[j].DataBinding.FieldName);
          dFdDy[k].FdDysName := trim(Tv1.Columns[j].Caption);
        end;
      end;

      k := k + 1;
    end;
  except
    application.MessageBox('加载数组错误！', '错误信息', MB_ICONERROR);
    exit;
  end;

  MovePanel1.Visible := True;
  MovePanel1.Refresh;

  ADOQueryCmd.Connection.BeginTrans;
  try
    for i := 2 to ExcelRowCount do
    begin

      with ADOQueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('select * from CK_Yarn_CR where 1=2');
        open;
      end;

      ADOQueryCmd.Append;
      //添加第i条数据
      for j := 0 to k - 1 do
      begin
        if trim(dFdDy[j].FDdys) <> '' then
          ADOQueryCmd.fieldbyname(dFdDy[j].FDdys).Value := excelApp.Cells[i, dFdDy[j].inc].Value;
      end;

      ADOQueryCmd.FieldByName('Filler').Value := Trim(DName);
      ADOQueryCmd.FieldByName('Y_ID').Value := Trim(Maxno) + inttostr(i);
      ADOQueryCmd.FieldByName('KCID').Value := Trim(Maxno) + inttostr(i);
      ADOQueryCmd.FieldByName('CKName').Value := '纱线';
      ADOQueryCmd.FieldByName('CRTime').Value := formatdateTime('yyyy-MM-dd', now);
      ADOQueryCmd.FieldByName('FillCode').Value := Trim(DCode);
      ADOQueryCmd.FieldByName('Filltime').Value := SGetServerDate(ADOQueryTemp);
      ADOQueryCmd.FieldByName('CRType').Value := '采购入库';
      ADOQueryCmd.FieldByName('CKName').Value := '纱线';
      ADOQueryCmd.FieldByName('CRFlag').Value := '入库';
      ADOQueryCmd.FieldByName('QtyUnit').Value := 'Kg';
      ADOQueryCmd.FieldByName('CRQtyFlag').Value := 1;
      ADOQueryCmd.Post;

      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('Update CK_Yarn_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_Yarn_CR A where A.KCID=CK_Yarn_CR.Y_ID )');
        sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_Yarn_CR A where A.KCID=CK_Yarn_CR.Y_ID )');
        sql.Add(' where Y_ID=''' + Trim(Maxno) + inttostr(i) + '''');
       // ShowMessage(SQL.Text);
        ExecSQL;
      end;
    end;
    WorkBook.Close;
    excelApp.Quit;
    excelApp := Unassigned;
    WorkBook := Unassigned;
    ADOQueryCmd.Connection.CommitTrans;
    MovePanel1.Visible := False;

    InitGrid();
  except
    WorkBook.Close;
    excelApp.Quit;
    excelApp := Unassigned;
    WorkBook := Unassigned;
    MovePanel1.Visible := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('保存数据错误！', '错误信息', MB_ICONERROR);
    exit;
  end;
end;

procedure TfrmShaRKList.Tv1DblClick(Sender: TObject);
begin
  try
    frmOldShaRKList := TfrmOldShaRKList.Create(Application);
    with frmOldShaRKList do
    begin
      FY_CodeName := Trim(Self.CDS_Main.fieldbyname('Y_CodeName').AsString);
      FY_Spec := Trim(Self.CDS_Main.fieldbyname('Y_Spec').AsString);
      FFactoryName := Trim(Self.CDS_Main.fieldbyname('FactoryName').AsString);
      FY_CF := Trim(Self.CDS_Main.fieldbyname('Y_CF').AsString);
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmOldShaRKList.Free;
  end;
end;

end.

